/* Sistemas Integrados TECNISA
   Servios

Nome: PEDCUST_COMP_PROD

Descrio:
   Traz o custo do produto de composio
Criao:
28/07/05 - Welbert G. Moitinha 
Alterao:
30/06/2011 - Giancarlo V. Catsro
   - Incluso da instruo que atualiza o grupo de operadores das Filiais que utilizam parametrizao pela Filial Padro*/

CREATE OR REPLACE FUNCTION PEDCUST_COMP_PROD (  P_CDPRODUTO    IN PRODUTO.CDPRODUTO%TYPE,
                                             P_CDFILIAL     IN FILIAL.CDFILIAL%TYPE,
                                             P_TIPOCUSTO    IN NUMBER,
                                             P_QTDE         IN FLOAT,
                                             P_CDLOJA       IN VARCHAR2,
                                             P_DTREFERENCIA IN DATE DEFAULT SYSDATE
                                           )RETURN FLOAT
AS
   V_CUSTO          FLOAT;
   V_CDFILIAL       VARCHAR2(4);
   V_CDALMOXARIFE   VARCHAR2(6);
   V_CDLOCALESTOQ   VARCHAR2(6);
   V_INCTREG        INTEGER;

   V_CDPRODUTORF    ROTFABRICA.CDPRODUTO%TYPE;
   V_CDSUBPRODUTORF ROTFABRICA.CDSUBPRODUTO%TYPE;
   V_QTSUBPRODROTRF ROTFABRICA.QTSUBPRODROT%TYPE;

   V_CDFILIALRL     ROTFABLOCAL.CDFILIAL%TYPE;
   V_CDPRODUTORL    ROTFABLOCAL.CDPRODUTO%TYPE;
   V_CDSUBPRODUTORL ROTFABLOCAL.CDSUBPRODLOC%TYPE;
   V_QTSUBPRODROTRL ROTFABLOCAL.QTSUBPRODLOC%TYPE;

   V_IDUTILLOTE     PARAMFILIAL.IDUTILLOTE%TYPE;
   V_NRLOTEESTQ     LOTE.NRLOTEESTQ%TYPE;
   V_NRSUBLOTE      LOTE.NRSUBLOTE%TYPE;

   CURSOR C_ROTFABRICA IS
   SELECT
      CDPRODUTO, CDSUBPRODUTO, QTSUBPRODROT
   FROM
      ROTFABRICA
   WHERE
      (CDPRODUTO = P_CDPRODUTO);

   CURSOR C_ROTFABLOCAL IS
   SELECT
      CDPRODUTO, CDSUBPRODLOC,  QTSUBPRODLOC
   FROM
      ROTFABLOCAL
   WHERE
      (CDFILIAL     = P_CDFILIAL)  AND
      (CDPRODUTO    = P_CDPRODUTO);
BEGIN
   V_CDFILIAL := P_CDFILIAL;
   V_CUSTO := 0;

   SELECT COUNT(*)
   INTO V_INCTREG
   FROM
      ROTFABRICA
   WHERE
      (CDPRODUTO = P_CDPRODUTO)AND
      (CDPRODUTO = CDSUBPRODUTO);

   IF(V_INCTREG = 0)THEN
      SELECT  COUNT(*)
      INTO V_INCTREG
      FROM
         ROTFABLOCAL
      WHERE
         (CDPRODUTO = P_CDPRODUTO)AND
         (CDPRODUTO = CDSUBPRODLOC);
   END IF;

   IF(V_INCTREG = 0)THEN

      V_CDFILIAL :=  COMP_LOCAL( P_CDFILIAL,  P_CDPRODUTO);

      IF( V_CDFILIAL = 'P')THEN

         OPEN C_ROTFABRICA;
         LOOP
            FETCH C_ROTFABRICA INTO V_CDPRODUTORF, V_CDSUBPRODUTORF, V_QTSUBPRODROTRF;
            EXIT WHEN C_ROTFABRICA%NOTFOUND;

            V_CUSTO := V_CUSTO + ROUND((PEDCUST_COMP_PROD( V_CDSUBPRODUTORF, P_CDFILIAL, P_TIPOCUSTO, V_QTSUBPRODROTRF, P_CDLOJA )), 4);
         END LOOP;
         CLOSE C_ROTFABRICA;
         RETURN(V_CUSTO);
      ELSE
         IF  V_CDFILIAL = P_CDFILIAL THEN
            OPEN C_ROTFABLOCAL;
            LOOP
               FETCH C_ROTFABLOCAL INTO V_CDPRODUTORF, V_CDSUBPRODUTORF, V_QTSUBPRODROTRF;
               EXIT WHEN C_ROTFABLOCAL%NOTFOUND;
               V_CUSTO := V_CUSTO + ROUND((PEDCUST_COMP_PROD( V_CDSUBPRODUTORF, P_CDFILIAL, P_TIPOCUSTO, V_QTSUBPRODROTRF, P_CDLOJA )), 4);
            END LOOP;
            CLOSE C_ROTFABLOCAL;
            RETURN(V_CUSTO);
         ELSE
            IF V_CDFILIAL = 'N' THEN

               V_CDALMOXARIFE := BUSCA_ALMOX(P_CDFILIAL, '', P_CDPRODUTO);
               V_CDLOCALESTOQ := BUSCA_LOCAL(P_CDFILIAL, '', P_CDPRODUTO);

               V_IDUTILLOTE := 'N';
               V_NRLOTEESTQ := ' ';
               V_NRSUBLOTE := ' ';

               SELECT MAX(IDUTILLOTE)
                 INTO V_IDUTILLOTE
                 FROM PARAMFILIAL
                WHERE CDFILIAL = P_CDFILIAL;

/* Foi retirado o parmetro de controle de lote por produto porque o relatrio posio de estoque
            no testa este parmetro. Estava dando diferena de custo do Pedido com o Estoque.  
               IF NVL(V_IDUTILLOTE, 'N') = 'S' THEN
                  SELECT MAX(IDUTCTRLLOTE)
                    INTO V_IDUTILLOTE
                    FROM PRODFILI
                   WHERE CDFILIAL = P_CDFILIAL
                     AND CDPRODUTO = P_CDPRODUTO;
               END IF;   */

               IF NVL(V_IDUTILLOTE, 'N') = 'S' THEN
                  /* Passa mais um dia para data no SQL 'P_DTREFERENCIA + 1' porque a POSESTDIA grava a
                     data com mais um dia. Na funo de CUSTO no  necessrio fazer este controle. */
                  SELECT MIN(NRLOTEESTQ), MIN(NRSUBLOTE)
                    INTO V_NRLOTEESTQ, V_NRSUBLOTE
                    FROM POSESTDIA B
                   WHERE B.CDFILIAL = P_CDFILIAL
                     AND B.CDPRODUTO = P_CDPRODUTO
                     AND B.CDALMOXARIFE  = V_CDALMOXARIFE
                     AND B.CDLOCALESTOQ  = V_CDLOCALESTOQ
                     AND ABS(B.QTESTOQDIA) > 0.00001
                     AND B.DTPOSIESTQ = (SELECT MAX(P.DTPOSIESTQ)
                                           FROM POSESTDIA P
                                          WHERE P.CDFILIAL = P_CDFILIAL
                                            AND P.CDPRODUTO = B.CDPRODUTO
                                            AND P.CDALMOXARIFE = V_CDALMOXARIFE
                                            AND P.CDLOCALESTOQ = V_CDLOCALESTOQ
                                            AND P.NRLOTEESTQ = B.NRLOTEESTQ
                                            AND P.NRSUBLOTE = B.NRSUBLOTE
                                            AND P.DTPOSIESTQ <= P_DTREFERENCIA + 1);
               END IF;

               V_CUSTO := V_CUSTO + ROUND(CUSTO_PRODUTO_LCEST(P_CDFILIAL, P_CDPRODUTO, P_TIPOCUSTO, P_DTREFERENCIA, SYSDATE,
                                          V_CDALMOXARIFE, V_CDLOCALESTOQ, V_NRLOTEESTQ, V_NRSUBLOTE) * P_QTDE, 4);
            END IF;
         END IF;
      END IF;
   END IF;
   RETURN(V_CUSTO);
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('PEDCUST_COMP_PROD','5.05.004'); END;
/
